﻿Imports System.Runtime.CompilerServices

Module Module1
    <Extension>
    Public Sub ShowWithParentFormLock(ByVal childForm As Form, ByVal parentForm As Form)
        ShowWithParentFormLock(childForm, parentForm, Nothing)
    End Sub

    <Extension>
    Public Sub ShowWithParentFormLock(ByVal childForm As Form, ByVal parentForm As Form, ByVal actionAfterClose As Action)
        If (childForm Is Nothing) Then
            Throw New ArgumentNullException("childForm")
        End If
        If (parentForm Is Nothing) Then
            Throw New ArgumentNullException("parentForm")
        End If

        Dim activatedDelegate As EventHandler = Sub(sender, e)
                                                    childForm.Activate()
                                                End Sub

        AddHandler childForm.FormClosed, Sub(ByVal sender As Object, ByVal closedEventArgs As FormClosedEventArgs)
                                             Try
                                                 parentForm.Enabled = True
                                                 parentForm.MaximumSize = New Drawing.Size(0, 0)
                                                 parentForm.MinimumSize = New Drawing.Size(0, 0)
                                                 parentForm.Focus()

                                                 If (actionAfterClose IsNot Nothing) Then
                                                     actionAfterClose.Invoke
                                                 End If
                                             Finally
                                                 Try
                                                     RemoveHandler parentForm.Activated, activatedDelegate
                                                     RemoveHandler parentForm.GotFocus, activatedDelegate
                                                     If (Not childForm.IsDisposed OrElse Not childForm.Disposing) Then
                                                         childForm.Dispose()
                                                     End If
                                                 Catch ex As Exception
                                                 End Try
                                             End Try
                                         End Sub
        AddHandler parentForm.Activated, activatedDelegate
        parentForm.Enabled = False
        'parentForm.MaximumSize = parentForm.Size
        'parentForm.MinimumSize = parentForm.Size
        childForm.Show(parentForm)
    End Sub

End Module
